% Generate intensity image lam

fprintf('If you have multiple cores on your machine, you can make this code run faster by first running "matlabpool 4" or "matlabpool 2" and then running this script.\n');

f = double(imread('saturn.tif'));
f = f((1:128)+173,(1:128)+50);
f = f/max(f(:));
I = 2;
lam = I*f;
x = poissrnd(lam);
n = sum(x(:));

figure(1); imagesc(lam); axis image; colormap gray;
figure(2); imagesc(x,[min(lam(:)) max(lam(:))]); axis image; colormap gray;
drawnow;

% gamma is a tuning parameter; large gamma does more smoothing and uses
% fewer platelets, small gamma does less smoothing and uses more platelets.
gamma = 0.4;

% average over "numCycleSpins" random shifts
numCycleSpins = 20;

% compute the platelet estimate
estPlatelet = plateletCycleSpin(x, n, gamma, numCycleSpins);

a = 20; b = size(f,1)-a+1;;

figure(3); imagesc([lam(a:b,a:b) x(a:b,a:b) estPlatelet(a:b,a:b)],[min(lam(:)) max(lam(:))]); axis image; colormap gray;
