function[err] = err(data, est, varargin)
% function[err] = err(est, data, noiseType='Poisson')
if nargin == 3
  noiseType = varargin{1};
else
  noiseType = 'Poisson';
end
if strcmpi(noiseType, 'Poisson')
  err = zeros(size(data));
  filter = (data>0 | est>0);
  if(any(filter(:)))
    err(filter) = (est(filter)-data(filter).*log(est(filter)));
  end
elseif strcmpi(noiseType, 'Gaussian')
  err = (est-data).^2;
else
  exception = MException('ArgumentError:Value', 'noiseType must be either Poisson or Gaussian.');
  throw(exception);
end
end
