function[plateFit] = fitMaskedPlatelet(obs, mask)
[m n] = size(obs);
[i,j] = meshgrid(1:n,1:m);
T = [ones(m*n,1) i(:) j(:)];

obs_masked = obs(mask);
K = sum(mask(:));
T_masked = [ones(K,1) i(mask) j(mask)];
coeffs_masked = pinv(T_masked)*obs_masked;
plateFit1 = reshape(T*coeffs_masked,m,n);

obs_masked = obs(~mask);
K = sum((1-mask(:)));
T_masked = [ones(K,1) i(~mask) j(~mask)];
coeffs_masked = pinv(T_masked)*obs_masked;
plateFit0 = reshape(T*coeffs_masked,m,n);

plateFit = max(plateFit1.*mask + plateFit0.*(1-mask),0);
end

