function est = plateletCycleSpin(x,n,t,K)
pen = ((1)*log(n))*t;
pen_w = ((4/3)*log(n))*t;
numWedges = floor(n^(2/3));

est = zeros(size(x));
if K>1
  ttotal = tic;
  for k = 1:K
    s = round(rand(2, 1) * size(x, 1));
    trun = tic;
    estk = plateletApprox(circshift(x, s), 'Poisson', pen, pen_w, numWedges);
    duration = toc(trun);
    est = est + circshift(estk, -s)/K;
    fprintf('cycle shift = %d/%d, time = %f\n', k, K, duration);
  end
  total = toc(ttotal);
  fprintf('total time = %f\n', total);
  fprintf('average time = %f\n', total/K);
else
  trun = tic;
  est = plateletApprox(x, 'Poisson', pen, pen_w, numWedges);
  duration = toc(trun);
  fprintf('time = %f\n', duration);
end